﻿Option Strict On
Imports System.Linq
Imports System.Xml.Linq
Public Class myUdons
    Dim myName As String
    Dim myPrice As String

    Public Property Name() As String
        Get
            Return myName
        End Get
        Set(ByVal value As String)
            myName = value
        End Set
    End Property

    Public Property Price() As String
        Get
            Return myPrice
        End Get
        Set(ByVal value As String)
            myPrice = value
        End Set
    End Property
End Class

Partial Public Class Page
    Inherits UserControl

    Dim xmldoc As String
    Dim doc As XElement

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub Page_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        doc = XElement.Load("udons.xml")
        Dim query = From c In doc.Elements("Udon") Where c.<Name>.Value.Equals("うどん(小)") Select c
        Dim hinmei As String = String.Empty
        Dim kakaku As String = String.Empty

        For Each result In query
            hinmei = result.Element("Name").Value
            kakaku = result.Element("Price").Value
        Next
        Dim myDoc As XDocument = New XDocument(New XDeclaration("1.0", "utf-8", "yes"), _
                                    New XElement("Udons", New XElement("Udon", _
                                    New XElement("Name", hinmei), _
                                    New XElement("Price", kakaku))))

        xmldoc = myDoc.ToString

        Dim doc2 As XElement = XElement.Parse(xmldoc)
        Dim query2 = From c In doc2.Elements("Udon") Select c
        Dim udonInfo As New List(Of myUdons)
        For Each result In query2
            With udonInfo
                .Add(New myUdons With {.Name = result.Element("Name").Value, _
                                       .Price = result.Element("Price").Value})
            End With
        Next
        Dim sumQuery = Aggregate c In doc2.Elements("Udon") Into Sum(Integer.Parse(c.<Price>.Value))
        TextBlock1.Text = sumQuery.ToString & "円"
        DataGrid1.ItemsSource = udonInfo
    End Sub

    Private Sub menu_ebiten_MouseLeftButtonDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles menu_ebiten.MouseLeftButtonDown
        ebiten.Visibility = Windows.Visibility.Visible
        DataSearchMakeXml("えび天")
        DataRecord()
        menu_ebiten.Visibility = Windows.Visibility.Collapsed
        ebiten_t.Begin()
    End Sub

    Private Sub menu_yasaiten_MouseLeftButtonDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles menu_yasaiten.MouseLeftButtonDown
        yasaiten.Visibility = Windows.Visibility.Visible
        DataSearchMakeXml("野菜天(二品)")
        DataRecord()
        menu_yasaiten.Visibility = Windows.Visibility.Collapsed
        yasaiten_t.Begin()
    End Sub

    Private Sub menu_jakoten_MouseLeftButtonDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles menu_jakoten.MouseLeftButtonDown
        jakoten.Visibility = Windows.Visibility.Visible
        DataSearchMakeXml("じゃこ天")
        DataRecord()
        menu_jakoten.Visibility = Windows.Visibility.Collapsed
        jakoten_t.Begin()
    End Sub

    Private Sub menu_tamago_MouseLeftButtonDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles menu_tamago.MouseLeftButtonDown
        tamago.Visibility = Windows.Visibility.Visible
        DataSearchMakeXml("たまご(時価)")
        DataRecord()
        menu_tamago.Visibility = Windows.Visibility.Collapsed
        tamago_t.Begin()
    End Sub

    Private Sub menu_agemaki_MouseLeftButtonDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles menu_agemaki.MouseLeftButtonDown
        agemaki.Visibility = Windows.Visibility.Visible
        DataSearchMakeXml("あげ巻き錦巻き")
        DataRecord()
        menu_agemaki.Visibility = Windows.Visibility.Collapsed
        agemaki_t.Begin()
    End Sub


    Private Sub menu_reset_MouseLeftButtonDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles menu_reset.MouseLeftButtonDown
        menu_ebiten.Visibility = Windows.Visibility.Visible
        menu_yasaiten.Visibility = Windows.Visibility.Visible
        menu_tamago.Visibility = Windows.Visibility.Visible
        menu_jakoten.Visibility = Windows.Visibility.Visible
        menu_agemaki.Visibility = Windows.Visibility.Visible
        Dim myZahyo As TranslateTransform = New TranslateTransform
        ebiten.Visibility = Windows.Visibility.Collapsed
        yasaiten.Visibility = Windows.Visibility.Collapsed
        tamago.Visibility = Windows.Visibility.Collapsed
        jakoten.Visibility = Windows.Visibility.Collapsed
        agemaki.Visibility = Windows.Visibility.Collapsed
        DataGrid1.ItemsSource = Nothing
        Page_Loaded(Nothing, Nothing)
    End Sub

    Sub DataSearchMakeXml(ByVal searchKey As String)
        Dim menu_hinmei As String = String.Empty
        Dim menu_kakaku As String = String.Empty
        Dim query = From c In doc.Elements("Udon") Where c.<Name>.Value.Equals(searchKey) Select c
        For Each result In query
            menu_hinmei = result.Element("Name").Value
            menu_kakaku = result.Element("Price").Value
        Next

        Dim doc2 As XElement = XElement.Parse(xmldoc)

        Dim myDoc As XElement = New XElement(New XElement("Udon", _
                                New XElement("Name", menu_hinmei), _
                                New XElement("Price", menu_kakaku)))
        doc2.Add(myDoc)
        xmldoc = doc2.ToString
    End Sub

    Sub DataRecord()
        Dim doc3 As XElement = XElement.Parse(xmldoc)
        Dim sumQuery = Aggregate c In doc3.Elements("Udon") Into Sum(Integer.Parse(c.<Price>.Value))

        Dim query2 = From c In doc3.Elements("Udon") Select c
        Dim udonInfo As New List(Of myUdons)
        For Each result In query2
            With udonInfo
                .Add(New myUdons With {.Name = result.Element("Name").Value, _
                                       .Price = result.Element("Price").Value})
            End With
        Next
        TextBlock1.Text = sumQuery.ToString & "円"
        DataGrid1.ItemsSource = udonInfo
    End Sub
End Class